
import
  std/typetraits, preserves

type
  Output* {.preservesRecord: "recv-json".} = object
    `field0`*: Preserve[void]

  JsonTranslatorArguments* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: Preserve[void]

  JsonSocketTranslatorArguments* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: Preserve[void]
    `socket`*: string

  Input* {.preservesRecord: "send-json".} = object
    `field0`*: Preserve[void]

proc `$`*(x: Output | JsonTranslatorArguments | JsonSocketTranslatorArguments |
    Input): string =
  `$`(toPreserve(x))

proc encode*(x: Output | JsonTranslatorArguments | JsonSocketTranslatorArguments |
    Input): seq[byte] =
  encode(toPreserve(x))
